#pragma config FPLLODIV = DIV_1,FPLLMUL = MUL_20,FPLLIDIV = DIV_2
#pragma config FWDTEN = OFF,FPBDIV = DIV_1,POSCMOD = XT,FNOSC = PRIPLL,CP = OFF
#pragma config FMIIEN = OFF,FETHIO = OFF	
#pragma config UPLLEN = ON,UPLLIDIV = DIV_2

#include "TCPIP Stack/TCPIP.h"

APP_CONFIG AppConfig; //   TCP/IP 

ROM BYTE SerializedMACAddress[6] =  
	{MY_DEFAULT_MAC_BYTE1,MY_DEFAULT_MAC_BYTE2,MY_DEFAULT_MAC_BYTE3,
 	MY_DEFAULT_MAC_BYTE4,MY_DEFAULT_MAC_BYTE5,MY_DEFAULT_MAC_BYTE6};

void InitAppConfig(void);  //   
void InitializeBoard(void); //   

int main(void)
{
	InitializeBoard(); //  
TickInit();	      //  
	InitAppConfig();   //  
      StackInit();       //  

   	while(1)                         //  
    	{
        StackTask();		//   
        StackApplications();    //   
	}
}

void InitializeBoard(void)
{	
	//  LEDs
	LED0_TRIS = 0;
	LED1_TRIS = 0;
	LED2_TRIS = 0;
	LED_PUT(0x00);

	// 
	INTEnableSystemMultiVectoredInt();
		
	//   
	SYSTEMConfigPerformance(GetSystemClock());
	mOSCSetPBDIV(OSC_PB_DIV_1);				
	CNPUESET = 0x00098000; // pullup    
}

void InitAppConfig(void)
{
	memset((void*)&AppConfig, 0x00, sizeof(AppConfig));
	AppConfig.Flags.bIsDHCPEnabled = TRUE;
	AppConfig.Flags.bInConfigMode = TRUE;
	memcpypgm2ram((void*)&AppConfig.MyMACAddr, 
		(ROM void*)SerializedMACAddress, sizeof(AppConfig.MyMACAddr));
	AppConfig.MyIPAddr.Val = MY_DEFAULT_IP_ADDR_BYTE1 | 
		MY_DEFAULT_IP_ADDR_BYTE2<<8ul | MY_DEFAULT_IP_ADDR_BYTE3<<16ul |
		MY_DEFAULT_IP_ADDR_BYTE4<<24ul;
	AppConfig.DefaultIPAddr.Val = AppConfig.MyIPAddr.Val;	
	AppConfig.MyMask.Val = MY_DEFAULT_MASK_BYTE1 | MY_DEFAULT_MASK_BYTE2<<8ul
		| MY_DEFAULT_MASK_BYTE3<<16ul | MY_DEFAULT_MASK_BYTE4<<24ul;
	AppConfig.DefaultMask.Val = AppConfig.MyMask.Val;
	AppConfig.MyGateway.Val = MY_DEFAULT_GATE_BYTE1 | 
		MY_DEFAULT_GATE_BYTE2<<8ul | MY_DEFAULT_GATE_BYTE3<<16ul | 
		MY_DEFAULT_GATE_BYTE4<<24ul;		
	AppConfig.PrimaryDNSServer.Val = MY_DEFAULT_PRIMARY_DNS_BYTE1 | 
		MY_DEFAULT_PRIMARY_DNS_BYTE2<<8ul  | 
		MY_DEFAULT_PRIMARY_DNS_BYTE3<<16ul  | 
		MY_DEFAULT_PRIMARY_DNS_BYTE4<<24ul;
	AppConfig.SecondaryDNSServer.Val = MY_DEFAULT_SECONDARY_DNS_BYTE1 | 
		MY_DEFAULT_SECONDARY_DNS_BYTE2<<8ul  | 
		MY_DEFAULT_SECONDARY_DNS_BYTE3<<16ul  | 
		MY_DEFAULT_SECONDARY_DNS_BYTE4<<24ul;
}
